<template>
  <base-dialog v-if="isInputInvalid" @close="closeDialog">
    <template #header>InputError 😖</template>
    <template #default>
      <p>Unfortunately Value is Invalid</p>
      <p>Please Check the Input</p>
    </template>
    <template #actions>
      <base-button @click="closeDialog" option="OK"></base-button>
    </template>
  </base-dialog>
  <base-card>
    <form @submit.prevent="submitData">
      <div class="form-control">
        <label for="title">Title</label>
        <input type="text" id="title" name="title" ref="titleInput" />
      </div>
      <div class="form-control">
        <label for="description">Description</label>
        <textarea id="description" rows="3" ref="descInput" />
      </div>
      <div class="form-control">
        <label for="link">Link</label>
        <input type="url" id="link" name="link" ref="linkInput" />
      </div>
      <div>
        <base-button type="submit" option="Submit"> </base-button>
      </div>
    </form>
  </base-card>
</template>

<script>
export default {
  inject: ['addResource'],
  data: function() {
    return {
      isInputInvalid: false
    };
  },
  methods: {
    submitData: function() {
      const title = this.$refs.titleInput.value;
      const description = this.$refs.descInput.value;
      const link = this.$refs.linkInput.value;
      if (
        title.trim() === '' ||
        description.trim() === '' ||
        link.trim() === ''
      ) {
        this.isInputInvalid = true;
        return;
      }
      this.addResource(title, description, link);
    },
    closeDialog: function() {
      this.isInputInvalid = false;
    }
  }
};
</script>

<style scoped>
label {
  font-weight: bold;
  display: block;
  margin-bottom: 0.5rem;
}

input,
textarea {
  display: block;
  width: 100%;
  font: inherit;
  padding: 0.4rem;
  border: 1px solid #ccc;
  border-radius: 6px;
  transition: 0.2s;
}

input:focus,
textarea:focus {
  outline: none;
  border-color: #3a0061;
  background-color: #f7ebff;
}

.form-control {
  margin: 1rem 0;
}
</style>
